function randomChar() {
  const chars = " ✧ :-゜・．* ✹ .            ";
  return chars[Math.floor(Math.random() * chars.length)];
}

function replaceText(node) {
  if (node.nodeType === Node.TEXT_NODE) {
    const text = node.textContent;
    const replaced = text
      .split("")
      .map(() => randomChar())
      .join("");
    node.textContent = replaced;
  } else if (node.nodeType === Node.ELEMENT_NODE) {
    for (const child of node.childNodes) {
      replaceText(child);
    }
  }
}

function handleDOMChange() {
  const nodes = document.querySelectorAll("body *");
  for (const node of nodes) {
    replaceText(node);
  }
}

const observer = new MutationObserver(handleDOMChange);
observer.observe(document.body, {
  attributes: true,
  childList: true,
  subtree: true,
});
